unit T_Box;  { oggetto di messaggio per l' editor }

interface

{$ifdef BP7}
uses crt, altro;
{$endif}
{$ifdef FP}
uses crt,mouse,math, altro32;
{$endif}

type   Messaggio=object
        Txt,Titolo:string;
        txt_ColorMessaggio,txt_ColorCornice,bk_color,  { colori }
        bk_bottone,color_bottone,color_tasto_veloce,color_selezione,Error,
        x1,y1,x2,y2, { posizione finestra } selezionato,esc,elementi:byte;
        controllo{ se la finestra entra nel monitor },tastiera,topo:boolean;
        constructor init;
        destructor  destroy;
        function    NuovoBottone(testo:string; tasto:byte):byte;  {torna la posizione dove inserito}
        function    RimuoviBottone(posiz:byte):byte;  {0=rimosso, 1=non c'era}
        function    Costruisci:byte;  { custruisce la parte grafica }
        function    Esegui:byte; { ritorna il tasto premuto }
        procedure   Assegna(var m2:Messaggio);
       end;

implementation

type pos_=record
          x1,x2,y:byte;
          end;

type tipo=record
          nome:string;
          Tasto:byte;
          end;

const  num=19;

var push: array [1..num] of tipo;
    old_selezionato:byte;
    posiz: array [1..num] of pos_;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Messaggio.NuovoBottone(testo:string; tasto:byte):byte;
begin   {nuovo bottone inserito alla fine }
if elementi=num then
   begin
   Error:=1;
   exit;
   end;
inc(elementi);
push[elementi].nome:=testo;
push[elementi].Tasto:=tasto;
NuovoBottone:=elementi;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

constructor Messaggio.init;
var i:byte;
begin
txt:='';
esc:=0;
controllo:=false;
selezionato:=1;
titolo:='';
x1:=1;
y1:=1;
x2:=1;
y2:=1;
Error:=0;
Color_Selezione:=7;
txt_ColorCornice:=7;
txt_ColorMessaggio:=7;
bk_bottone:=7;
color_bottone:=7;
bk_color:=0;
elementi:=0;
tastiera:=true;
topo:=true;
for i:=1 to num do
    begin
    push[i].nome:='';
    push[i].Tasto:=0;
    end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure stampa_selezionato(bk_color,color_bottone,selezionato,Color_Selezione:byte);
begin    { seleziona con [] il selezionato, e rimuove quello vecchio }
if old_selezionato=selezionato then Exit;
hidemouse;
if old_selezionato>0 then
   begin
   gotoxy(posiz[old_selezionato].x1,posiz[old_selezionato].y);
   textbackground(bk_color);
   write(' ');
   gotoxy(posiz[old_selezionato].x2,posiz[old_selezionato].y);
   textbackground(bk_color);
   write(' ');
   end;
gotoxy(posiz[selezionato].x1,posiz[selezionato].y);
textbackground(bk_color);
textcolor(Color_Selezione);
write('[');
gotoxy(posiz[selezionato].x2,posiz[selezionato].y);
textbackground(bk_color);
textcolor(Color_Selezione);
write(']');
showmouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure scelta_rapida(s:string; tasto,color_bottone,color_tasto_veloce:byte);
var i:byte;
begin
i:=pos(char(tasto),s);
write(copy(s,1,i-1));
if i>0 then
   begin
   textcolor(color_tasto_veloce);
   write(copy(s,i,1));
   end;
textcolor(color_bottone);
write(copy(s,i+1,255));
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Dimensioni(x2,y2:byte):byte;
var x,y:byte;
begin
x:=GetTextMaxX;
y:=GetTextMaxY;
if y2>y then Dimensioni:=12 else
if x2>x then Dimensioni:=12 else
if (x2=x)and(y2=y) then dimensioni:=12 else dimensioni:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Messaggio.RimuoviBottone(posiz:byte):byte;  {0=rimosso, 1=non c'era}
var i:byte;
begin
if (posiz>elementi)or(posiz<1) then rimuovibottone:=1
                  else
                   begin
                   for i:=posiz to elementi-1 do
                       begin
                       push[i].nome:=push[i+1].nome;
                       push[i].Tasto:=push[i+1].Tasto;
                       end;
                   dec(elementi);
                   rimuovibottone:=0;
                   end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Messaggio.Costruisci:byte;
var s,s1:string;
    lunghezza_max,j,i,maxY,wx:byte;
begin
hidemouse;
if esc>elementi then
     begin
     Error:=13;
     RunError(201);
     exit;
     end;
if (not tastiera) and (not topo) then
   begin
   Error:=2;
   RunError(201);
   exit;
   end;
if elementi=0 then
   begin
   error:=3;
   RunError(201);
   exit;
   end;
if selezionato>elementi then
   begin
   Error:=4;
   RunError(201);
   Exit;
   end;
if selezionato<1 then
   begin
   Error:=5;
   RunError(201);
   Exit;
   end;
if controllo then
   begin
   Error:=dimensioni(x2,y2);
   if Error<>0 then
      begin
      RunError(201);
      Exit;
      end;
   end;
old_selezionato:=0;
for i:=1 to elementi do
    for j:=1 to length(push[i].nome) do
        if push[i].nome[j]<#32 then
                               begin
                               Error:=6;
                               RunError(201);
                               Exit;
                               end;
textcolor(txt_ColorCornice);
textbackground(bk_color);
if (x1>x2) or (y1>y2) then
   begin
   Error:=7;
   RunError(201);
   Exit;
   end;
lunghezza_max:=x2-x1+1;
s:='';
if titolo<>'' then s:=' '+titolo+' ';
if length(s)>lunghezza_max-2 then
   begin
   Error:=8;
   RunError(201);
   Exit;
   end;
s1:='';
for i:=1 to lunghezza_max-2 do s1:=s1+'';   { #205 }
Insert(s,S1,(length(s1) div 2)-(length(s) div 2)+1);
s1:=copy(s1,1,lunghezza_max-2);
cursorOff;
gotoxy(x1,y1);
write(''+s1+'');   { #201 #? }
gotoxy(x1,y2);
s:='';
while length(s)<x2-x1-1 do s:=s+'';
s:=''+s+'';
write(s);   { #200 #188 }
s:='';
for i:=1 to lunghezza_max-2 do s:=s+' ';
for i:=y1+1 to y2-1 do
    begin
    gotoxy(x1,i);
    write(''+s+'');     { #186 }
    end;
s:='';
for i:=1 to length(txt) do if ord(txt[i])>31 then s:=s+txt[i];
textcolor(txt_ColorMessaggio);
i:=0;
while s<>'' do            { stampo il messaggio }
      begin
      inc(i);
      gotoxy(x1+1,y1+i);
      maxy:=wherey;       { massima y su cui scrivo }
      if (wherex>x2)or(maxy>=y2) then
         begin
         Error:=9;
         RunError(201);
         Exit;
         end;
      write(copy(s,1,x2-x1-1));
      s:=copy(s,x2-x1,255);
      wx:=wherex;
      end;
j:=0;
for i:=1 to elementi do j:=j+length(push[i].nome);
j:=j+elementi*4;          { i caratteri che servono per stampare i tasti }
if j>x2-x1-1 then
   begin
   Error:=11;
   RunError(201);
   Exit;
   end;
gotoxy(x1+((x2-x1-j+1) div 2), trunc(min( (y2- (y2-maxY) div 2),y2-1)) );
if (maxY=wherey)and(wx>=wherex) then
   begin
   Error:=11;
   RunError(201);
   Exit;
   end;

for i:=1 to elementi do
    begin
    textbackground(blue);
    write(' ');
    posiz[i].y:=wherey;
    textbackground(bk_bottone);
    textcolor(color_bottone);
    posiz[i].x1:=wherex-1;        { posizione del bottone }
    if not (char(push[i].tasto) in ['0'..'9','a'..'z','A'..'Z',#1,#27]) then
                 begin
                 Error:=10;
                 RunError(201);
                 Exit;
                 end;
    scelta_rapida(' '+push[i].nome+' ',push[i].tasto,color_bottone,color_tasto_veloce);
    posiz[i].x2:=wherex;          { posizione del bottone }
    textbackground(blue);
    write(' ');
    end;
stampa_selezionato(bk_color,color_bottone,selezionato,Color_Selezione);
showmouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Messaggio.Assegna(var m2:Messaggio);
var i:byte;
begin
m2.init;
m2.Txt:=txt;
m2.Titolo:=Titolo;
m2.txt_ColorMessaggio:=txt_ColorMessaggio;
m2.txt_ColorCornice:=txt_ColorCornice;
m2.bk_color:=bk_color;
m2.bk_bottone:=bk_bottone;
m2.color_bottone:=color_bottone;
m2.color_tasto_veloce:=color_tasto_veloce;
m2.color_selezione:=color_selezione;
m2.Error:=Error;
m2.x1:=x1;
m2.y1:=y1;
m2.x2:=x2;
m2.y2:=y2;
m2.selezionato:=selezionato;
m2.esc:=esc;
m2.controllo:=controllo;
m2.tastiera:=tastiera;
m2.topo:=topo;
for i:=1 to elementi do m2.NuovoBottone(push[i].nome, push[i].tasto);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Messaggio.Esegui:byte;
var c:char;
    i,mox,moy,tasto:byte;
begin
Esegui:=0;
repeat
 if keypressed then
     begin
     c:=readkey;
     if not tastiera then continue;
     case ord(c) of
          27: if (esc>0)and(esc<=elementi) then
                 begin
                 Esegui:=esc;
                 Exit;
                 end;
          13,32:
             begin
             Esegui:=selezionato;
             Exit;
             end;
          9: begin { tab }
             old_selezionato:=selezionato;
             if selezionato<elementi then inc(selezionato)
                                     else selezionato:=1;
             stampa_selezionato(bk_color,color_bottone,selezionato,Color_Selezione);
             end;
          0: begin
             c:=readkey;
             case ord(c) of
                  77: begin { freccia di destra, come il tab }
                      old_selezionato:=selezionato;
                      if selezionato<elementi then inc(selezionato)
                                              else selezionato:=1;
                      stampa_selezionato(bk_color,color_bottone,selezionato,Color_Selezione);
                      end;
                  75: begin { freccia di sinistra }
                      old_selezionato:=selezionato;
                      if selezionato>1 then dec(selezionato)
                                       else selezionato:=elementi;
                      stampa_selezionato(bk_color,color_bottone,selezionato,Color_Selezione);
                      end;
                   else
                    for i:=1 to elementi do { ho premuto un tasto alt+selezionato? quale? }
                        if (push[i].Tasto=ord(from_alt_to_char(ord(c)))) and (push[i].Tasto<>1) then
                                       begin
                                       Esegui:=i;
                                       Exit;
                                       end;
                  end;
             end
          else
           for i:=1 to elementi do { ho premuto un tasto selezionato? quale? }
               if upcase(char(push[i].Tasto))=upcase(c) then
                                      begin
                                      Esegui:=i;
                                      Exit;
                                      end;
          end;
     end;
 if topo then
     begin
     Rilascio(mox,moy,tasto); {restituisce rilascio del mouse in mox,moy,tasto}
     if tasto=1 then
        for i:=1 to elementi do
            if (mox>posiz[i].x1)and(mox<posiz[i].x2)and(posiz[i].y=moy) then
                                begin
                                Esegui:=i;
                                Exit;
                                end;
     end;
until true;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

destructor Messaggio.destroy;
begin
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

begin
end.


 Error
   0  : nesssun errore
   1  : troppi tasti inseriti
   2  : tastiera e mouse disabilitati (*)
   3  : 0 elementi (*)
   4  : selezionato>elementi (*)
   5  : selezionato<1 (*)
   6  : il nome del bottone contiene caratteri non validi (<#32) (*)
   7  : coordinate non valide: (x1>x2) or (y1>y2) (*)
   8  : titolo troppo lungo (*)
   9  : il testo non entra nella finestra (*)
   10 : tasto di scalta rapido non compreso tra  a..z  o  A..Z, #27, #1 (non assegnato) (*)
   11 : la finestra e' troppo stretta per contenere tutti i bottoni ed il testo (*)
   12 : se la finestra non entra nel monitor (*)
   13 : ESC>elementi (*)
(*)  quando chiamo il metodo Costruisci

function NuovoBottone(testo:string; tasto:byte):byte;
 { torna la posizione dove inserito
   Se non si ha un tasto di scelta rapida, inserire il numero 1 }

La variabile 'esc' contiene il bottone a cui associare il tasto ESC se premuto